When submitting a solution in C++, please select either C++14 (GCC 6-32) or C++17 (GCC 7-32) as your compiler. ×

dalex's blog

By dalex, 6 years ago, translation, In English
  • Vote: I like it
  • +88
  • Vote: I do not like it

| Write comment?
»
6 years ago, # |
  Vote: I like it +13 Vote: I do not like it

Can I register with my team? Or only individual contestants?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +8 Vote: I do not like it

    You can, but people on the onsite contest played individually.

»
6 years ago, # |
  Vote: I like it +4 Vote: I do not like it

Will there be an editorial after the contest. It becomes really hard to get solutions for all the problems from the comments for beginners like me.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

I enjoyed the contest, the problems were really interesting. Can I see the case I'm failing at on problem M?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +3 Vote: I do not like it

    This test has n = 3.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      I'm like brute forcing, so maybe it's some logical bug.

      Can you share the full test? :)

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone share his code for C.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +2 Vote: I do not like it

    Code

    I'm not sure how clear it is but I can explain anything if it's unclear.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Could you please explain how your code works. This is my Code. The Idea is same as yours I guess but its giving wrong answer on Test 11.

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it +2 Vote: I do not like it

        I start by sorting the ranges by their end points. Then as I'm processing the end points, ill greedily build my set.

        Basically, if by the time I get to the end of some range and there's no number in my set (that's the ceiling() call) that belongs in it's range, then I'll add that range's endpoint to the set.

        This is always optimal because I'm going in increasing order of endpoints so every time I add a number to my set, it's as large as possible so it's most likely to fit in the other ranges (who all have end points greater than the current one).

        • »
          »
          »
          »
          »
          6 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          Why I sort the ranges by their start points then I got wrong answer ? But sort the ranges by their end points will get AC ?

»
6 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Any hint for problem H or L???

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +5 Vote: I do not like it

    Problem H:

    BFS off of every monster tile and only go a maximum of d distance away. Any tile that was touched by a monster's BFS is now no longer usable. Now BFS from your starting point and do regular shortest path in a grid but making sure to ignore cells touched by the monsters.

    Problem L:

    For every position i in the string, find the next position of every letter in the alphabet. Now keep some kind of queue and find the next position of whatever letter is queried (or pop the back of your queue). If the next position of the queried letter doesn't exist, the answer is no otherwise it's yes.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      So simple BFS's were enough in H? I thought that with n*m up to 4*10^10 that would take too long, even just to calculate 'bad' cells

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      For H,first i DFS for each 'M' finding which grid can't reach, then BFS for shortest path, but wrong answer on test 20,i really wanna know what test 20 data is,thx~

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it
      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it -8 Vote: I do not like it

        Yeah I too got a WA on test 20 , but I don't know why this approach gives WA with dfs

        • »
          »
          »
          »
          »
          6 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          Test 22 is here, most probably you can't pass it too.
          Test 20 is the same but with other parameters:

          Spoiler
          • »
            »
            »
            »
            »
            »
            6 years ago, # ^ |
              Vote: I like it -8 Vote: I do not like it

            But can you help me out why, am I getting a wrong answer. Is doing dfs to find cells at distance d wrong?

            • »
              »
              »
              »
              »
              »
              »
              6 years ago, # ^ |
                Vote: I like it 0 Vote: I do not like it

              Yep, it's definitely wrong. You may visit some cell with distance X <= M, and then, when you will try to visit it again with distance Y < X <= M, you will ignore that edge because cell already visited. So the fix is change visited array type from boolean to int (shortest distance from M to that cell), but in that case I think you may get stuck with TLE.

              • »
                »
                »
                »
                »
                »
                »
                »
                6 years ago, # ^ |
                Rev. 3   Vote: I like it 0 Vote: I do not like it

                Yeah I encountered a TLE, with bfs

                • »
                  »
                  »
                  »
                  »
                  »
                  »
                  »
                  »
                  6 years ago, # ^ |
                  Rev. 2   Vote: I like it 0 Vote: I do not like it
                  1. Don't run bfs from each M separately (run normal bfs, just put all 'M' together to the queue with H=0)
                  2. Try to replace HashMap by array
                • »
                  »
                  »
                  »
                  »
                  »
                  »
                  »
                  »
                  5 years ago, # ^ |
                  Rev. 2   Vote: I like it 0 Vote: I do not like it

                  can someone explain why this code gives MLE (the queueis full ) i used bfs from all M then one bFS from s for path length https://pastebin.com/ip8Q1hH8 solved : I have to mark the node visited than added to the queue not the inverse

»
6 years ago, # |
Rev. 3   Vote: I like it 0 Vote: I do not like it

What's output of problem E for this test case: abaca aabac

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

What is the test 48 on F?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +5 Vote: I do not like it

    During the contest this test helps me:

    4
    3 2 3 4
    1 4
    1 4
    0
    

    Answer is NO

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Any hints on how to approach I? My approach can't seem to get past test 12.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +3 Vote: I do not like it

    I used this approach:

    Define a procedure findRoot(vertices, leafs, depth) for search a tree root among vertices, inside it we need to find two leafs from a different subtrees (relative to root). It can be managed in O(size(vertices)), then you can easily find a root (it is a vertex, that dist(leaf1, v) = dist(leaf2, v) = depth). Then you need to run findRoot recursively from left/right subtree.

    So, each findRoot procedure takes 2 * size(vertices) queries (2 * nlogn in total) and additional queries at start to find leafs.

    • »
      »
      »
      6 years ago, # ^ |
      Rev. 2   Vote: I like it 0 Vote: I do not like it

      That makes a lot of sense. Thank you!

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it +3 Vote: I do not like it

      Hi, I can't figure it out how do you manage to classify vertex according to left and right subtree for the recursive call. Can you explain that part? Because you pass vertices and leafs parameters that, I guess, represent vertices and leafs of the current subtree.

      Thanks

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        You have two leafs from different subtrees, so lets call them left & right. So to classify arbitrary vertex we need to compare dist(left, vertext) and dist(right, vertex) — if dist from vertex to left vertex smaller then vertex in a left subtree and vice versa.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Could you show me the code? I try many many ways but i still can't figure it out.

      Thanks.

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        It's very easy to include interactor in the solution and test it locally. All tests for this problem are just trees with random-shuffled vertex indices (there are no any special cases). So it doesn't seem you "tried many many ways".

        • »
          »
          »
          »
          »
          6 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          That's because I make too many queries then I get a wrong answer,but i have no idea how to reduce the query though I know my ways can restore the tree.

          • »
            »
            »
            »
            »
            »
            6 years ago, # ^ |
              Vote: I like it 0 Vote: I do not like it
            Spoiler
»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

What's test 22 on H ?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it +9 Vote: I do not like it
    Test 22 generator
»
6 years ago, # |
  Vote: I like it +29 Vote: I do not like it

The game .C.O.N.T.E.S.T: Unexpected Behaviour from Problem K "Video Reviews" does not exist. But recently our gamedev team Veslo Games released the game .T.E.S.T: Expected Behaviour (from creator of Codeforces Simulator!) to the Steam Early Access. If you like puzzles, consider checking this out!

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

is there a algorithm about problem M?or it's just a simulation?

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it
    Spoiler, M
»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

could anybody help me with the problom I, I can't pass the test 5

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    This test has n = 7 and random-shuffled vertices.

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      thanks a lot,but i'm stuck in test 12 now, trust me,i will figure it out :( lol

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

I am stuck on problem H 8-th test . Can I see the case I'm failing ?

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anyone provide any hints for problem K ,video reviews? thanks.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Main hint: binary search

    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      thanks for replying.binary search i figured out but was not able to come up with a predicate.thanks.

      • »
        »
        »
        »
        6 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Suppose we have X, and we need to check if X is enough to get m reviews. You need to process the bloggers from left to right. There are two options:

        • blogger is already interested in the game — just increase reviews count
        • blogger isn't interested in the game — you need to convince him (if already convienced count < X) and increase reviews count.

        It can be easily proven that greedy algorithm works.

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

What is the test case 50 in problem F? I got stucked there :(

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it
    F, test 48
    F, test 50
    • »
      »
      »
      6 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Thanks, I don't know why my aproach was wrong. At the end I changed my strategy and get AC.

      Do you have any hint for problem D? I belive that a maxflow algorithm could said if it is possible or not, but I can't construct the solution

      • »
        »
        »
        »
        6 years ago, # ^ |
        Rev. 2   Vote: I like it 0 Vote: I do not like it
        Certificate in D
»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

What is the test case 52 in problem F? I got stucked there.

  • »
    »
    6 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    The same as test 48 (see my comment above), but with different random seed

»
6 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone that give hints about questions D, G and I ? I'm stuck on those.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

May I get some help about 112 No. test case of problem No. F ???

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +3 Vote: I do not like it

    The same as test 48 and 52 (see my comment above), but with different random seed

»
5 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

Problem H. Safe Path

WA on Test Case 124 :(

I am stuck.

Here's My Code:

https://codeforces.com/gym/101755/submission/48191879

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Beautiful problems, solved all, recommend to everybody

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Any hints of for problem D?